/*!
* \mainpage
*
* @section intro License
* Use of this program is subject to Atmel's End User License Agreement.
*
* Please read file  \ref lic_page for copyright notice.
*
* \section section1 Description
*   This application drives a BLDC motor with trapezoidal waveforms\n
*   The motor runs in the sensored mode \n
*   It runs on an ATAVRMC303 board with an ATxMega128A1 part\n
*   The main source files are :
*
*         -  main.c             main loop
*         -  mc_control.c       PI regulation
*         -  mc_drv.c           hardware level of motor control
*
*         -  mc_interface.c     interface routines to motor control
*
*         -  ushell_task.c      command interpreter from an ascii chain
*         -  ascii.c            ascii to binary conversion
*
*
* \section section2 Preamble
* All parameters are given for the motor included in the kit with no load.\n
* They must be ajusted according to the application (motor, load ...)\n
* The ramp-up sequence must be adjusted to the motor and load\n
* \n
*
*
* \section section3 User Manual
*   - At power on, the motor starts running
*   - The reference speed is ajusted with the DB101 extension board
*
* \subsection subsection1 List of Material
*   - ATAVRMC303 
*   - ATAVRMC300 (Power Board)
*
*/
