/**
  * @brief 30 degres interrupt
*/
#pragma vector = TCE1_OVF_vect
__interrupt void thirty_degres_interrupt(void)
{
  char direction = mci_get_motor_direction();

  if (mci_motor_is_running())
  {

        switch(motor_step)
        {
          case (MS_100):
            if (direction==CCW)  {Set_Q1Q4();motor_step=MS_101;}
            else                 {Set_Q5Q2();motor_step=MS_110;}
            break;
      
          case (MS_110):
            if (direction==CCW)  {Set_Q5Q4();motor_step=MS_100;}
            else                 {Set_Q3Q2();motor_step=MS_010;}
            break;
      
          case (MS_010):
            if (direction==CCW)  {Set_Q5Q2();motor_step=MS_110;}
            else                 {Set_Q3Q6();motor_step=MS_011;}
            break;
      
          case (MS_011):
            if (direction==CCW)  {Set_Q3Q2();motor_step=MS_010;}
            else                 {Set_Q1Q6();motor_step=MS_001;}
            break;
      
          case (MS_001):
            if (direction==CCW)  {Set_Q3Q6();motor_step=MS_011;}
            else                 {Set_Q1Q4();motor_step=MS_101;}
            break;
      
          case (MS_101):
            if (direction==CCW)  {Set_Q1Q6();motor_step=MS_001;}
            else                 {Set_Q5Q4();motor_step=MS_100;}
            break;
      
          default :
            Set_none(); // all switches are switched OFF
            motor_step=MS_010;
            break;
      
        } 
    TCE0.CTRLA = TC_CLKSEL_OFF_gc; // stop timer of Demagnetisation
    TCE1.CTRLA = TC_CLKSEL_OFF_gc; // stop timer of 30
    TCE0.CNT = 0; 
    TCE1.CNT = 0;     
    TCE0.PER = ADVANCE;
    TCE1.PER = 0xFFFF;    
    TCE0.INTCTRLA = TC_OVFINTLVL_LO_gc;   
    TCE1.INTCTRLA = TC_OVFINTLVL_LO_gc;       
    TCE0.CTRLA = TC_CLKSEL_DIV8_gc; // start timer of Demagnetisation        
    TCE1.CTRLA = TC_CLKSEL_DIV8_gc; // start timer of 30            
  }
}

/**
* @brief end of demagnetization delay interrupt
*/
#pragma vector = TCE0_OVF_vect
__interrupt void demag_interrupt(void)
{

  switch(motor_step)
  {
    case (MS_100):
//      Enable_IT_comparator0();
         AC_ConfigMUX(&AC, ANALOG_COMPARATOR0, AC_MUXPOS_PIN2_gc, AC_MUXNEG_PIN0_gc);
         AC_Enable(&AC, ANALOG_COMPARATOR0, true);           
      break;

    case (MS_110):
//      Enable_IT_comparator1();
        AC_ConfigMUX(&AC, ANALOG_COMPARATOR0, AC_MUXPOS_PIN3_gc, AC_MUXNEG_PIN1_gc);
        AC_Enable(&AC, ANALOG_COMPARATOR0, true);      
      break;

    case (MS_010):
//      Enable_IT_comparator2();
        AC_ConfigMUX(&AC, ANALOG_COMPARATOR0, AC_MUXPOS_PIN4_gc, AC_MUXNEG_PIN7_gc);	
        AC_Enable(&AC, ANALOG_COMPARATOR0, true);
      
      break;

    case (MS_011):
//      Enable_IT_comparator0();
         AC_ConfigMUX(&AC, ANALOG_COMPARATOR0, AC_MUXPOS_PIN2_gc, AC_MUXNEG_PIN0_gc);
         AC_Enable(&AC, ANALOG_COMPARATOR0, true);     
      break;

    case (MS_001):
//      Enable_IT_comparator1();
        AC_ConfigMUX(&AC, ANALOG_COMPARATOR0, AC_MUXPOS_PIN3_gc, AC_MUXNEG_PIN1_gc);
        AC_Enable(&AC, ANALOG_COMPARATOR0, true);  
      break;

    case (MS_101):
//      Enable_IT_comparator2();
        AC_ConfigMUX(&AC, ANALOG_COMPARATOR0, AC_MUXPOS_PIN4_gc, AC_MUXNEG_PIN7_gc);	
        AC_Enable(&AC, ANALOG_COMPARATOR0, true);
      break;

    default :
//      Enable_IT_comparator2_1_0();
      motor_step=MS_010;
      break;
  }

  TCE0.CTRLA = TC_CLKSEL_OFF_gc; // stop timer Demag
}



#pragma vector = ACA_AC0_vect
__interrupt void mc_comparator(void)
{
  U16 top;

  TCE1.CTRLA = TC_CLKSEL_OFF_gc; // stop timer of 30
  top = TCE1.CNT;
  TCE1.CNT = 0; 
  TCE1.PER = top;
  TCE1.INTCTRLA = TC_OVFINTLVL_LO_gc;   
  TCE1.CTRLA = TC_CLKSEL_DIV8_gc; // start timer 30
  
//  Disable_IT_comparator2_1_0();
  AC_Disable(&AC, ANALOG_COMPARATOR0);  
}  
  
void start_running_phase(void)
{
  /*
  U16 top;
  TCCR1B = 0 ; // stop timer 1
  top_average = TIMER1_AT_STARTUP_END;
  top = (top_average >> 1);
  TCNT1H = HIGH(top);
  TCNT1L = LOW(top);
  OCR1AH = 0;
  OCR1AL = 0;
  top = top + (top_average >> 2);
  OCR1BH = HIGH(top);
  OCR1BL = LOW(top);
  TCCR1B = (1<<CS11) | (1<<CS10) ; // start timer 1
  TIFR1 = (1<<OCF1B) | (1<<OCF1A) | (1<<TOV1);
  TIMSK1= (1<<OCIE1B) | (1<<OCIE1A); // Output compare A Match interrupt Enable
  */
  TCE0.CTRLA = TC_CLKSEL_OFF_gc; // stop timer of DEMAG
  TCE1.CTRLA = TC_CLKSEL_OFF_gc; // stop timer of 30
  top_average = 0xFFFF;//TIMER1_AT_STARTUP_END*128;
  // 30  
  TCE1.PER = top_average;
  TCE1.CNT = 0;
  TCE1.INTCTRLA = TC_OVFINTLVL_LO_gc;
  // Demag
  TCE0.PER = ADVANCE;
  TCE0.CNT = 0;
  TCE0.INTCTRLA = TC_OVFINTLVL_LO_gc;
  
  TCE0.CTRLA = TC_CLKSEL_DIV8_gc; // start timer Demag
  TCE1.CTRLA = TC_CLKSEL_DIV8_gc; // start timer 30
}
